# Copyright (c) ETSI 2019.
# https://forge.etsi.org/etsi-forge-copyright-notice.txt
definitions:
  Link:
    description: >
      This type represents a link to a resource using an absolute URI.
    type: object
    required:
      - href
    properties:
      href:
        description: >
          URI of another resource referenced from a resource.
          Shall be an absolute URI (i.e. a UTI that contains {apiRoot}).
        $ref: "#/definitions/Uri"

  NotificationLink:
    description: >
      This type represents a link to a resource in a notification, using an absolute or relative URI.
    type: object
    required:
      - href
    properties:
      href:
        description: >
          URI of a resource referenced from a notification.
          Should be an absolute URI (i.e. a URI that contains
          {apiRoot}), however, may be a relative URI (i.e. a URI
          where the {apiRoot} part is omitted) if the {apiRoot}
          information is not available.
        $ref: "#/definitions/Uri"

  KeyValuePairs:
    description: >
      This type represents a list of key-value pairs. The order of the pairs in the list is not significant. In JSON,
      a set of keyvalue pairs is represented as an object. It shall comply with the provisions defined in clause 4
      of IETF RFC 8259. In the following example, a list of key-value pairs with four keys ("aString", "aNumber",
      "anArray" and "anObject") is provided to illustrate that the values associated with different keys can be of
      different type.
    type: object

  ApiVersionInformation:
    description: >
      This type represents API version information.
    type: object
    required:
      - uriPrefix
      - apiVersions
    properties:
      uriPrefix:
        description: >
          Specifies the URI prefix for the API, in the following
          form {apiRoot}/{apiName}/{apiMajorVersion}/.
        type: string
      apiVersions:
        description: >
          Version(s) supported for the API signaled by the
          uriPrefix attribute.
        type: array
        items:
          type: object
          required:
            - version
          properties:
            version:
              description: >
                Identifies a supported version. The value of the
                version attribute shall be a version identifier as
                specified in clause 9.1 (SOL013).
              type: string
            isDeprecated:
              description: >
                If such information is available, this attribute indicates
                whether use of the version signaled by the version
                attribute is deprecated (true) or not (false).

                A deprecated version is still supported by the API producer but is recommended
                not to be used any longer.
                When a version is no longer supported, it does not appear in the response body.
              type: boolean
            retirementDate:
              description: >
                The date and time after which the API version will no
                longer be supported.
                This attribute may be included if the value of the
                isDeprecated attribute is set to true and shall be
                absent otherwise.
              $ref: "#/definitions/DateTime"

  Identifier:
    description: >
      An identifier with the intention of being globally unique.
    type: string

  IdentifierInManoEntity:
    description: >
      An identifier that is unique for the respective type within a NFV-MANO functional entity,
      but that need not be globally unique. Representation: string of variable length..
    type: string

  IdentifierLocal:
    description: >
      An identifier that is unique within a limited local scope other than above listed identifiers,
      such as within a complex data structure or within a request-response pair.
      Representation: string of variable length.
    type: string

  DateTime:
    description: >
      Date-time stamp.
      Representation: String formatted according to IETF RFC 3339.
    type: string
    format: date-time

  Uri:
    description: >
      String formatted according to IETF RFC 3986.
    type: string

  Boolean:
    description: >
      The Boolean is a data type having two values (true and false).
    type: boolean

  Version:
    description: >
      A version.
    type: string

  String:
    description: >
      A string defined in IETF RFC 8259.
    type: string

  Number:
    description: >
      A number defined in IETF RFC 8259.
    type: number

  ProblemDetails:
    description: >
      The definition of the general "ProblemDetails" data structure from
      IETF RFC 7807 [19] is reproduced inthis structure. Compared to the
      general framework defined in IETF RFC 7807 [19], the "status" and
      "detail" attributes are mandated to be included by the present document,
      to ensure that the response contains additional textual information about
      an error. IETF RFC 7807 [19] foresees extensibility of the
      "ProblemDetails" type. It is possible that particular APIs in the present
      document, or particular implementations, define extensions to define
      additional attributes that provide more information about the error.
      The description column only provides some explanation of the meaning to
      Facilitate understanding of the design. For a full description, see
      IETF RFC 7807 [19].
    type: object
    required:
      - status
      - detail
    properties:
      type:
        description: >
          A URI reference according to IETF RFC 3986 [5] that identifies the
          problem type. It is encouraged that the URI provides human-readable
          documentation for the problem (e.g. using HTML) when dereferenced.
          When this member is not present, its value is assumed to be
          "about:blank".
        type: string
        format: URI
      title:
        description: >
          A short, human-readable summary of the problem type. It should not
          change from occurrence to occurrence of the problem, except for
          purposes of localization. If type is given and other than
          "about:blank", this attribute shall also be provided.
          A short, human-readable summary of the problem
          type.  It SHOULD NOT change from occurrence to occurrence of the
          problem, except for purposes of localization (e.g., using
          proactive content negotiation; see [RFC7231], Section 3.4).
        type: string
      status:
        description: >
          The HTTP status code for this occurrence of the problem.
          The HTTP status code ([RFC7231], Section 6) generated by the origin
          server for this occurrence of the problem.
        type: integer
      detail:
        description: >
          A human-readable explanation specific to this occurrence of the
          problem.
        type: string
      instance:
        description: >
          A URI reference that identifies the specific occurrence of the
          problem. It may yield further information if dereferenced.
        type: string
        format: URI
      #TODO: How to express "any additional attributes"?

  SubscriptionAuthentication:
    type: object
    required:
      - authType
    properties:
      authType:
        description: >
          Defines the types of Authentication / Authorization which the API
          consumer is willing to accept when receiving a notification.
          Permitted values:
          * BASIC: In every HTTP request to the notification endpoint, use
            HTTP Basic authentication with the client credentials.
          * OAUTH2_CLIENT_CREDENTIALS: In every HTTP request to the
            notification endpoint, use an OAuth 2.0 Bearer token, obtained
            using the client credentials grant type.
          * TLS_CERT: Every HTTP request to the notification endpoint is sent
            over a mutually authenticated TLS session, i.e. not only the
            server is authenticated, but also the client is authenticated
            during the TLS tunnel setup.
        type: array
        items:
          type: string
          enum:
            - BASIC
            - OAUTH2_CLIENT_CREDENTIALS
            - TLS_CERT
      paramsBasic:
        description: >
          Parameters for authentication/authorization using BASIC.
          Shall be present if authType is "BASIC" and the contained
          information has not been provisioned out of band.
          Shall be absent otherwise.
        type: object
        properties:
          userName:
            description: >
              Username to be used in HTTP Basic authentication. Shall be
              present if it has not been provisioned out of band.
            type: string
          password:
            description: >
              Password to be used in HTTP Basic authentication. Shall be
              present if it has not been provisioned out of band.
            type: string
      paramsOauth2ClientCredentials:
        description: >
          Parameters for authentication/authorization using
          OAUTH2_CLIENT_CREDENTIALS.
          Shall be present if authType is "OAUTH2_CLIENT_CREDENTIALS" and the
          contained information has not been provisioned out of band.
          Shall be absent otherwise.
        type: object
        properties:
          clientId:
            description: >
              Client identifier to be used in the access token request of the
              OAuth 2.0 client credentials grant type.
              Shall be present if it has not been provisioned out of band.
              The clientId and clientPassword passed in a subscription shall
              not be the same as the clientId and clientPassword that are used
              to obtain authorization for API requests. Client credentials may
              differ between subscriptions. The value of clientPassword should
              be generated by a random process.
            type: string
          clientPassword:
            description: >
              Client password to be used in the access token request of the
              OAuth 2.0 client credentials grant type.
              Shall be present if it has not been provisioned out of band.
              The clientId and clientPassword passed in a subscription shall
              not be the same as the clientId and clientPassword that are used
              to obtain authorization for API requests. Client credentials may
              differ between subscriptions. The value of clientPassword should
              be generated by a random process.
            type: string
          tokenEndpoint:
            description: >
              The token endpoint from which the access token can be obtained.
              Shall be present if it has not been provisioned out of band.
            $ref: "#/definitions/Uri"

  ManoManagedObjectReference:
    description: >
      This type represents the identifier to reference a managed object of a particular type.
      It shall comply with the provisions defined in Table 4.3.2.3-1.
    type: object
    required:
      - type
      - objectId
    properties:
      type:
          description: >
            Indicates the type of managed object.
          type: string
          enum:
            - MANO_ENTITY
            - MANO_SERVICE
            - MANO_SERVICE_IF
            - CONSUMED_MANO_IF
            - MANO_ENTITY_COMPONENT
      objectId:
          description: >
            Identifier of the managed object.
            - If type="MANO_ENTITY", it corresponds to the value of the attribute "id" of the "ManoEntity"
              representing an NFV-MANO functional entity.
            - If type="MANO_SERVICE", it corresponds to the value of the attribute "id" of the "ManoEntity"
              representing the NFV-MANO functional entity that contains the "ManoService" sub-object.
            - If type="MANO_SERVICE_IF", it corresponds to the value of the attribute "id" of the
              "ManoServiceInterface" representing the NFV-MANO functional entity that contains the
              "ManoServiceInterface" sub-object.
            - If type="CONSUMED_MANO_IF", the value corresponds to the value of the attribute "id" of the
              "ConsumedManoInterfaceInfo" representing a consumed NFV-MANO service interface from a peer
              functional entity.
            - If type="MANO_ENTITY_COMPONENT", the value corresponds to the value of the attribute "id" of the
              "ManoEntity" representing the NFV-MANO functional entity that contains the "ManoEntityComponent" sub-object.
          $ref: "#/definitions/Identifier"
      subObjectId:
          description: >
            Identifier of the managed sub-object. It shall be present if type equals to "MANO_SERVICE" or
            "MANO_SERVICE_IF" or "MANO_ENTITY_COMPONENT".

            - If type="MANO_SERVICE", it corresponds to the value of the attribute "id" of the "ManoService"
              representing an individual NFV-MANO service.
            - If type="MANO_SERVICE_IF", it corresponds to the value of the attribute "id" of the
              "ManoServiceInterface" representing an individual NFV-MANO service interface.
            - If type="MANO_ENTITY_COMPONENT", it corresponds to the value of the attribute "id" of the
              "ManoEntityComponent" representing an NFV-MANO functional entity component.
          $ref: "#/definitions/IdentifierInManoEntity"



